import math;
import hyperbolic_geometry;

size(500,500);
settings.outformat="pdf";

// What do we want to test?
// The calculation of intersection points of hyperbolic line segments with
// hyperbolic circles. Every intersection of a blue line with a circle in the
// picture should be marked with a dot of the circles' color. There should no
// dot appear elsewhere.

hyperbolic_point[] P;

P[0] = hyperbolic_point(1,30);
P[1] = hyperbolic_point(1,60);
P[2] = hyperbolic_point(2.4,210);
P[3] = hyperbolic_point(1.2,135);
P[4] = hyperbolic_point(0,5);
P[5] = hyperbolic_point(2,5);
P[6] = hyperbolic_point(2.8,80);
P[7] = hyperbolic_point(2.8,100);
P[8] = hyperbolic_point(1.2,80);
P[9] = hyperbolic_point(1.2,100);
P[10] = hyperbolic_point(1.6,200);
P[11] = hyperbolic_point(2,310);
P[12] = hyperbolic_point(1,110);
P[13] = hyperbolic_point(1.3,0);
P[14] = hyperbolic_point(1.8,45);
P[15] = hyperbolic_point(1.9,225);

hyperbolic_segment s[];
hyperbolic_segment last;
hyperbolic_point[] I;

for (int i=0; i< 15; ++i) {
    s[i] = hyperbolic_segment(P[i%15],P[(i+1)%15]);

    dot(s[i].get_first_point(), gray);
    dot(s[i].get_second_point(), gray);

    draw(s[i].get_line(), gray);
    draw(s[i], blue);
}

hyperbolic_circle HC = hyperbolic_circle(P[0], P[10]);
draw(HC, red);

for (int i = 0; i < s.length; ++i) {
    I = intersection(HC, s[i]);
    dot(I[0], red);
    dot(I[1], red);
}

hyperbolic_circle HC = hyperbolic_circle(hyperbolic_point(0,0), P[12]);
draw(HC, yellow);

for (int i = 0; i < s.length; ++i) {
    I = intersection(HC, s[i]);
    dot(I[0], yellow);
    dot(I[1], yellow);
}

draw((1,1)--(1,-1)--(-1,-1)--(-1,1)--cycle);
draw(unitcircle);
